=== debian/changelog ===
intel-ipsec-mb (1.0-1) unstable; urgency=medium

  * Sync to latest 1.0 release
  * Rename libipsec-mb0 to libipsec-mb1
  * Remove debian/watch as the upstream project is not serving tarballs now
  * Add note about elf debug optimization being disabled in rules
  * Add back the Uploaders field in the control file

 -- Colin Ian King <colin.king@canonical.com>  Fri, 7 May 2021 09:11:47 +0100
