## intel-ipsec-mb 1.2

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2020-2021, Intel Corporation
+# Copyright (c) 2020-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -51,6 +51,9 @@
 help:
 	$(MAKE) -C lib help
 
+doxy:
+	$(MAKE) -C lib doxy
+
 README: README.md
 	pandoc -f markdown -t plain $< -o $@
