=== lib/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2021, Intel Corporation
+# Copyright (c) 2012-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -80,14 +80,17 @@
 INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)
 
 CC ?= gcc
+# MINGW should be non-zero value if detected
+MINGW ?= $(shell $(CC) -dM -E - < /dev/null | grep -i mingw | wc -l | sed 's/^ *//')
 
 # if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
 # "-fcf-protection" needs to be checked separately
+ifeq ($(MINGW),0)
 CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
 	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
 CET_LDFLAGS=-r -z ibt -z shstk
-
-CFLAGS := -DLINUX -DNO_COMPAT_IMB_API_053 $(EXTRA_CFLAGS) $(INCLUDES) \
+endif
+CFLAGS := -DNO_COMPAT_IMB_API_053 $(EXTRA_CFLAGS) $(INCLUDES) \
 	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings  \
 	-Wformat -Wformat-security \
@@ -95,6 +98,10 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition \
 	-fno-strict-overflow -fno-delete-null-pointer-checks -fwrapv
 
+ifeq ($(MINGW),0)
+CFLAGS += -DLINUX
+endif
+
 ifeq ($(CC_HAS_CET),1)
 CFLAGS += -fcf-protection=full
 endif
@@ -102,10 +109,14 @@
 ASM_INCLUDE_DIRS := .
 
 YASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I $i)
+NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
+ifneq ($(MINGW),0)
+YASM_FLAGS := -f x64 -f win64 -X gnu -g dwarf2 -DWIN_ABI $(YASM_INCLUDES)
+NASM_FLAGS := -Werror -fwin64 -Xvc -gcv8 -DWIN_ABI $(NASM_INCLUDES)
+else
 YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__ $(YASM_INCLUDES)
-
-NASM_INCLUDES := $(foreach i,$(ASM_INCLUDE_DIRS),-I$i/)
 NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__ $(NASM_INCLUDES)
+endif
 
 DEBUG_OPT ?= -O0
 ifeq ($(DEBUG),y)
@@ -113,8 +124,19 @@
 OPT = $(DEBUG_OPT)
 LDFLAGS += -g
 else
+ifeq ($(MINGW),0)
 OPT = -O3
 CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
+else
+OPT = -O2
+LDFLAGS += -s
+endif
+endif
+
+ifeq ($(SAFE_OPTIONS), n)
+SAFE_DATA = n
+SAFE_PARAM = n
+SAFE_LOOKUP = n
 endif
 
 ifneq ($(SAFE_DATA),n)
@@ -133,6 +155,12 @@
 CFLAGS += -DSAFE_LOOKUP
 NASM_FLAGS += -DSAFE_LOOKUP
 YASM_FLAGS += -DSAFE_LOOKUP
+endif
+
+ifeq ($(AESNI_EMU),y)
+CFLAGS += -DAESNI_EMU
+NASM_FLAGS += -DAESNI_EMU
+YASM_FLAGS += -DAESNI_EMU
 endif
 
 # prevent SIMD optimizations for non-aesni modules
@@ -178,9 +206,13 @@
 # so or static build
 ifeq ($(SHARED),y)
 CFLAGS += -fPIC
+ifneq ($(MINGW),0)
+LIBNAME = $(LIB).dll
+else
 LIBNAME = $(LIB).so.$(VERSION)
+LDFLAGS += -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now
+endif
 LIBPERM = 0755
-LDFLAGS += -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now
 ifeq ($(CC_HAS_CET),1)
 LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
 endif
@@ -204,6 +236,8 @@
 SAFE_LOOKUP_MSG1="SAFE_LOOKUP option not set."
 SAFE_LOOKUP_MSG2="Lookups which depend on sensitive information \
 		are not guaranteed to be done in constant time."
+SAFE_OPTIONS_MSG1="SAFE_OPTIONS not specified."
+SAFE_OPTIONS_MSG2="All safe options enabled by default."
 
 #
 # List of C modules (any origin)
@@ -213,7 +247,6 @@
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
-	mb_mgr_sse_no_aesni.o \
 	alloc.o \
 	aes_xcbc_expand_key.o \
 	md5_one_block.o \
@@ -223,26 +256,31 @@
 	des_basic.o \
 	version.o \
 	cpu_feature.o \
-	aesni_emu.o \
 	kasumi_avx.o \
 	kasumi_iv.o \
 	kasumi_sse.o \
-	zuc_sse_top.o \
-	zuc_sse_no_aesni_top.o \
-	zuc_avx_top.o \
-	zuc_avx2_top.o \
-	zuc_avx512_top.o \
+	zuc_top_sse.o \
+	zuc_top_avx.o \
+	zuc_top_avx2.o \
+	zuc_top_avx512.o \
 	zuc_iv.o \
 	snow3g_sse.o \
-	snow3g_sse_no_aesni.o \
 	snow3g_avx.o \
 	snow3g_avx2.o \
+	snow3g_avx512.o \
 	snow3g_tables.o \
 	snow3g_iv.o \
-	snow_v_sse.o \
-	snow_v_sse_noaesni.o \
 	mb_mgr_auto.o \
 	error.o
+
+ifeq ($(AESNI_EMU), y)
+c_lib_objs := $(c_lib_objs) \
+	mb_mgr_sse_no_aesni.o \
+	aesni_emu.o \
+	zuc_top_sse_no_aesni.o \
+	snow3g_sse_no_aesni.o
+endif
+
 #
 # List of ASM modules (root directory/common)
 #
@@ -257,7 +295,7 @@
 	aes128_ecbenc_x3.o \
 	zuc_common.o \
 	wireless_common.o \
-	constant_lookup.o \
+	constant_lookup_fns.o \
 	crc32_refl_const.o \
 	crc32_const.o \
 	poly1305.o \
@@ -270,9 +308,9 @@
 	aes128_cbc_dec_by4_sse_no_aesni.o \
 	aes192_cbc_dec_by4_sse_no_aesni.o \
 	aes256_cbc_dec_by4_sse_no_aesni.o \
-	aes_cbc_enc_128_x4_no_aesni.o \
-	aes_cbc_enc_192_x4_no_aesni.o \
-	aes_cbc_enc_256_x4_no_aesni.o \
+	aes128_cbc_enc_x4_sse_no_aesni.o \
+	aes192_cbc_enc_x4_sse_no_aesni.o \
+	aes256_cbc_enc_x4_sse_no_aesni.o \
 	aes128_cntr_by8_sse_no_aesni.o \
 	aes192_cntr_by8_sse_no_aesni.o \
 	aes256_cntr_by8_sse_no_aesni.o \
@@ -282,28 +320,26 @@
 	pon_sse_no_aesni.o \
 	zuc_sse_no_aesni.o \
 	aes_cfb_sse_no_aesni.o \
-	aes128_cbc_mac_x4_no_aesni.o \
-	aes256_cbc_mac_x4_no_aesni.o \
-	aes_xcbc_mac_128_x4_no_aesni.o \
-	mb_mgr_aes_flush_sse_no_aesni.o \
-	mb_mgr_aes_submit_sse_no_aesni.o \
-	mb_mgr_aes192_flush_sse_no_aesni.o \
-	mb_mgr_aes192_submit_sse_no_aesni.o \
-	mb_mgr_aes256_flush_sse_no_aesni.o \
-	mb_mgr_aes256_submit_sse_no_aesni.o \
-	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
+	aes128_cbc_mac_x4_sse_no_aesni.o \
+	aes256_cbc_mac_x4_sse_no_aesni.o \
+	aes128_xcbc_mac_x4_sse_no_aesni.o \
+	mb_mgr_aes128_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes128_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes192_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes192_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes256_cbc_enc_flush_sse_no_aesni.o \
+	mb_mgr_aes256_cbc_enc_submit_sse_no_aesni.o \
+	mb_mgr_aes128_cmac_submit_flush_sse_no_aesni.o \
 	mb_mgr_aes256_cmac_submit_flush_sse_no_aesni.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse_no_aesni.o \
+	mb_mgr_aes128_ccm_auth_submit_flush_sse_no_aesni.o \
 	mb_mgr_aes256_ccm_auth_submit_flush_sse_no_aesni.o \
-	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
-	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
+	mb_mgr_aes128_xcbc_flush_sse_no_aesni.o \
+	mb_mgr_aes128_xcbc_submit_sse_no_aesni.o \
 	mb_mgr_zuc_submit_flush_sse_no_aesni.o \
 	ethernet_fcs_sse_no_aesni.o \
 	crc16_x25_sse_no_aesni.o \
-	aes_cbcs_1_9_enc_128_x4_no_aesni.o \
+	aes128_cbcs_1_9_enc_x4_sse_no_aesni.o \
 	aes128_cbcs_1_9_dec_by4_sse_no_aesni.o \
-	mb_mgr_aes128_cbcs_1_9_submit_sse.o \
-	mb_mgr_aes128_cbcs_1_9_flush_sse.o \
 	mb_mgr_aes128_cbcs_1_9_submit_sse_no_aesni.o \
 	mb_mgr_aes128_cbcs_1_9_flush_sse_no_aesni.o \
 	crc32_refl_by8_sse_no_aesni.o \
@@ -312,7 +348,9 @@
 	crc32_lte_sse_no_aesni.o \
 	crc32_fp_sse_no_aesni.o \
 	crc32_iuup_sse_no_aesni.o \
-	crc32_wimax_sse_no_aesni.o
+	crc32_wimax_sse_no_aesni.o \
+	snow_v_sse_no_aesni.o \
+	snow3g_uia2_sse_no_aesni.o
 
 #
 # List of ASM modules (sse directory)
@@ -324,72 +362,45 @@
 	aes192_cbc_dec_by8_sse.o \
 	aes256_cbc_dec_by4_sse.o \
 	aes256_cbc_dec_by8_sse.o \
-	aes_cbc_enc_128_x4.o \
-	aes_cbc_enc_192_x4.o \
-	aes_cbc_enc_256_x4.o \
-	aes_cbc_enc_128_x8_sse.o \
-	aes_cbc_enc_192_x8_sse.o \
-	aes_cbc_enc_256_x8_sse.o \
-	pon_sse.o \
+	aes128_cbc_enc_x4_sse.o \
+	aes192_cbc_enc_x4_sse.o \
+	aes256_cbc_enc_x4_sse.o \
+	aes128_cbc_enc_x8_sse.o \
+	aes192_cbc_enc_x8_sse.o \
+	aes256_cbc_enc_x8_sse.o \
+	pon_by8_sse.o \
 	aes128_cntr_by8_sse.o \
 	aes192_cntr_by8_sse.o \
 	aes256_cntr_by8_sse.o \
-	aes_ecb_by4_sse.o \
+	aes128_ecb_by4_sse.o \
+	aes192_ecb_by4_sse.o \
+	aes256_ecb_by4_sse.o \
 	aes128_cntr_ccm_by8_sse.o \
 	aes256_cntr_ccm_by8_sse.o \
 	aes_cfb_sse.o \
-	aes128_cbc_mac_x4.o \
-	aes256_cbc_mac_x4.o \
+	aes128_cbc_mac_x4_sse.o \
+	aes256_cbc_mac_x4_sse.o \
 	aes128_cbc_mac_x8_sse.o \
 	aes256_cbc_mac_x8_sse.o \
-	aes_xcbc_mac_128_x4.o \
+	aes128_xcbc_mac_x4_sse.o \
 	md5_x4x2_sse.o \
-	sha1_mult_sse.o \
+	sha1_x4_sse.o \
 	sha1_one_block_sse.o \
 	sha224_one_block_sse.o \
 	sha256_one_block_sse.o \
 	sha384_one_block_sse.o \
 	sha512_one_block_sse.o \
 	sha512_x2_sse.o \
-	sha_256_mult_sse.o \
+	sha256_mult_sse.o \
 	sha1_ni_x2_sse.o \
 	sha256_ni_x2_sse.o \
-	zuc_sse.o \
-	zuc_sse_gfni.o \
-	mb_mgr_aes_flush_sse.o \
-	mb_mgr_aes_submit_sse.o \
-	mb_mgr_aes192_flush_sse.o \
-	mb_mgr_aes192_submit_sse.o \
-	mb_mgr_aes256_flush_sse.o \
-	mb_mgr_aes256_submit_sse.o \
-	mb_mgr_aes_flush_sse_x8.o \
-	mb_mgr_aes_submit_sse_x8.o \
-	mb_mgr_aes192_flush_sse_x8.o \
-	mb_mgr_aes192_submit_sse_x8.o \
-	mb_mgr_aes256_flush_sse_x8.o \
-	mb_mgr_aes256_submit_sse_x8.o \
-	mb_mgr_aes_cmac_submit_flush_sse.o \
-	mb_mgr_aes256_cmac_submit_flush_sse.o \
-	mb_mgr_aes_cmac_submit_flush_sse_x8.o \
-	mb_mgr_aes256_cmac_submit_flush_sse_x8.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse.o \
-	mb_mgr_aes_ccm_auth_submit_flush_sse_x8.o \
-	mb_mgr_aes256_ccm_auth_submit_flush_sse.o \
-	mb_mgr_aes256_ccm_auth_submit_flush_sse_x8.o \
-	mb_mgr_aes_xcbc_flush_sse.o \
-	mb_mgr_aes_xcbc_submit_sse.o \
-	mb_mgr_hmac_md5_flush_sse.o \
-	mb_mgr_hmac_md5_submit_sse.o \
-	mb_mgr_hmac_flush_sse.o \
-	mb_mgr_hmac_submit_sse.o \
-	mb_mgr_hmac_sha_224_flush_sse.o \
-	mb_mgr_hmac_sha_224_submit_sse.o \
-	mb_mgr_hmac_sha_256_flush_sse.o \
-	mb_mgr_hmac_sha_256_submit_sse.o \
-	mb_mgr_hmac_sha_384_flush_sse.o \
-	mb_mgr_hmac_sha_384_submit_sse.o \
-	mb_mgr_hmac_sha_512_flush_sse.o \
-	mb_mgr_hmac_sha_512_submit_sse.o \
-	mb_mgr_hmac_flush_ni_sse.o \
-	mb_mgr_hmac_submit_ni_sse.o \
-	mb_mgr_hmac_sha_224_flush_ni_sse.o \
+	zuc_x4_sse.o \
+	zuc_gfni_sse.o \
+	mb_mgr_aes128_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes128_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes192_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes192_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes256_cbc_enc_flush_x4_sse.o \
+	mb_mgr_aes256_cbc_enc_submit_x4_sse.o \
+	mb_mgr_aes128_cbc_enc_flush_x8_sse.o \
+	mb_mgr_aes128_cbc_enc_submit_x8_sse.o \
