=== test/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2021, Intel Corporation
+# Copyright (c) 2012-2022, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -27,6 +27,8 @@
 
 TEST_APP := ipsec_MB_testapp
 XVALID_APP := ipsec_xvalid_test
+FUZZ_APP := job_api_fuzz_test
+ACVP_APP := acvp_app
 INSTPATH ?= /usr/include/intel-ipsec-mb.h
 LIB_DIR ?= ../lib
 
@@ -34,7 +36,9 @@
 YASM ?= yasm
 NASM ?= nasm
 
-CFLAGS = -MMD -DLINUX -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
+MINGW ?= $(shell $(CC) -dM -E - < /dev/null | grep -i mingw | wc -l | sed 's/^ *//')
+
+CFLAGS = -MMD -D_GNU_SOURCE -DNO_COMPAT_IMB_API_053 \
 	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
 	-Wcast-qual -Wundef -Wwrite-strings  \
 	-Wformat -Wformat-security \
@@ -44,18 +48,30 @@
 
 # if "-z ibt" is supported then assume "-z shstk, -z cet-report=error" are also supported
 # "-fcf-protection" needs to be checked separately
+ifeq ($(MINGW),0)
 CC_HAS_CET = $(and $(shell $(CC) --target-help 2> /dev/null | grep -m1 -e "-z ibt" | wc -l), \
 	$(shell $(CC) --help=common 2> /dev/null | grep -m1 -e "-fcf-protection" | wc -l))
 CET_LDFLAGS=-r -z ibt -z shstk
+endif
 
 ifeq ($(CC_HAS_CET),1)
 CFLAGS += -fcf-protection=full
 endif
 
 YASM_FLAGS := -f x64 -f elf64 -X gnu -g dwarf2 -DLINUX -D__linux__
+ifeq ($(MINGW),0)
+CFLAGS += -DLINUX
 NASM_FLAGS := -Werror -felf64 -Xgnu -gdwarf -DLINUX -D__linux__
-
+else
+NASM_FLAGS := -Werror -fwin64 -Xvc -gcv8 -DWIN_ABI
+endif
+
+ifeq ($(MINGW),0)
 LDFLAGS = -fPIE -z noexecstack -z relro -z now
+else
+LDFLAGS = -fPIE
+endif
+
 ifeq ($(CC_HAS_CET),1)
 LDFLAGS += -fcf-protection=full -Wl,-z,ibt -Wl,-z,shstk -Wl,-z,cet-report=error
 endif
@@ -69,14 +85,27 @@
 CFLAGS +=  -I../lib/include -I../lib
 LDFLAGS += -L$(LIB_DIR)
 endif
+
+FUZZ_CFLAGS = -I../lib -L../lib $(CFLAGS) -g -fsanitize=fuzzer,address,leak
 
 DEBUG_OPT ?= -O0
 ifeq ($(DEBUG),y)
 CFLAGS += $(DEBUG_OPT) -DDEBUG -g
 LDFLAGS += -g
 else
+ifeq ($(MINGW),0)
 CFLAGS += -O3
-endif
+else
+CFLAGS += -O2
+endif
+endif
+
+ACVP_LOC ?= /usr/local/acvp
+ACVP_HDR ?= $(ACVP_LOC)/include
+ACVP_LIB ?= $(ACVP_LOC)/lib
+ACVP_CFLAGS = -I$(ACVP_HDR) $(CFLAGS)
+ACVP_LDFLAGS = -L$(ACVP_LIB) $(LDFLAGS)
+ACVP_LDLIBS = -lacvp $(LDLIBS)
 
 # ipsec_MB_testapp modules
 SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
@@ -84,14 +113,24 @@
 	hmac_md5_test.c aes_test.c sha_test.c chained_test.c api_test.c pon_test.c \
 	ecb_test.c zuc_test.c kasumi_test.c snow3g_test.c direct_api_test.c clear_mem_test.c \
 	hec_test.c xcbc_test.c aes_cbcs_test.c crc_test.c chacha_test.c poly1305_test.c \
-	chacha20_poly1305_test.c null_test.c snow_v_test.c
+	chacha20_poly1305_test.c null_test.c snow_v_test.c direct_api_param_test.c
 OBJECTS := $(SOURCES:%.c=%.o)
+
+ifneq ($(PIN_CEC_ROOT),)
+CFLAGS += -I$(PIN_CEC_ROOT)/include -DPIN_BASED_CEC
+endif
 
 # ipsec_xvalid_test modules
 XVALID_ASM := misc.asm
 XVALID_SOURCES := ipsec_xvalid.c utils.c
 XVALID_OBJECTS := $(XVALID_SOURCES:%.c=%.o) $(XVALID_ASM:%.asm=%.o)
 
+# fuzz modules
+FUZZ_SOURCES := job_api_fuzz_test.c
+
+# acvp_app modules
+ACVP_SOURCES := acvp_app_main.c utils.c
+
 # list of present dependency files
 DEP_FILES = $(wildcard ./*.d)
 
@@ -108,7 +147,7 @@
 endif
 
 # targets come here
-all: $(TEST_APP) $(XVALID_APP)
+all: $(TEST_APP) $(XVALID_APP) $(FUZZ_APP) $(ACVP_APP)
 
 $(TEST_APP): $(OBJECTS)
 	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
@@ -116,9 +155,24 @@
 $(XVALID_APP): $(XVALID_OBJECTS)
 	$(CC) $(LDFLAGS) $^ $(LDLIBS) -o $@
 
+$(ACVP_APP): $(ACVP_SOURCES)
+ifneq ("$(wildcard $(ACVP_HDR))","")
+	$(CC) $(ACVP_CFLAGS) $(ACVP_LDFLAGS) $^ $(ACVP_LDLIBS) -o $@
+else
+	@echo "No libacvp header found at $(ACVP_HDR), $(ACVP_APP) is not built"
+endif
+
+$(FUZZ_APP): $(FUZZ_SOURCES)
+ifneq (, $(shell which clang))
+	clang $(FUZZ_CFLAGS) $(FUZZ_SOURCES) $(LDLIBS) -o $@
+else
+	@echo "Clang is not installed. $(FUZZ_APP) is not built"
+endif
+
+
 .PHONY: clean
 clean:
-	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS)
+	-rm -f $(OBJECTS) $(TEST_APP) $(DEP_FILES) $(XVALID_OBJECTS) $(XVALID_APP) $(ASM_OBJECTS) $(FUZZ_APP) $(ACVP_APP)
 
 # style check section
 CHECKPATCH?=checkpatch.pl
