=== debian/changelog ===
intel-ipsec-mb (1.2-1) unstable; urgency=medium

  * Sync to latest 1.2 release
  * Update maintainer to colin.i.king@gmail.com

 -- Colin Ian King <colin.i.king@gmail.com>  Fri, 18 Feb 2022 11:40:11 +0000

intel-ipsec-mb (1.1-1) unstable; urgency=medium

  * Sync to latest 1.1 release
  * Update maintainer to colin.king@ubuntu.com as they no longer
    work for Canonical.

 -- Colin Ian King <colin.king@ubuntu.com>  Fri, 29 Oct 2021 11:40:11 +0100
